var $;

/**
* onload
* Actions to perform on window load
*/
jQuery(function() {

	$ = jQuery.noConflict();

	// Validate Google Key
	if( $( '#blm-location-input' ).length ) {

		blmGeocode( 'blm-location-input', 'blm-location-results', function( result ) {

			// If a geocoding result was found, mark key as valid
			if( result ) {

				$( '#blm-field-note-container' ).attr( 'data-code', '1' );

			}

		} );

		setTimeout( function() {

			if( $( '#blm-field-note-container' ).attr( 'data-code' ) === '3' ) {
				$( '#blm-field-note-container' ).attr( 'data-code', '2' );
			}

		}, 3000 );

	}

	// Get the map append setting
	$( '#blm-setting-map-append-enabled' ).on( 'change', function() {
		$( '#blm-settings-section-map' ).attr( 'data-enabled', $( this ).val() );
	} );

	// Banner preview
	$( '#blm-banner-premade-options').on( 'change', function() {

		if( $( this ).find( 'option[value="' + $( this ).val() + '"]' ).length === 0 ) {
			return false;
		}

		var imgsrc = '<img src="https://api.bloom.li/static/nearby/search/images/buttons/ad-' + $( this ).val() + '.jpg" />';
		$( '#blm-banner-premade-preview' ).html( imgsrc );
		$( '#blm-shortcode-code-banner' ).html( blmHtmlEntities( '<blm-link data-type="search">' + imgsrc + '</blm-link>' ) );

	} );

	// Post type selection
	$( '.blm_setting_posttype' ).on( 'change', function() {
		$( this ).parent().parent().attr( 'data-type', $( this ).val() );
	} );

} );// Onload

/**
* blmHtmlEntities
* Translate HTML entities of given string
*/
function blmHtmlEntities( s ) {

	return String( s ).replace( /&/g, '&amp;' ).replace( /</g, '&lt;' ).replace( />/g, '&gt;' ).replace( /"/g, '&quot;' );

}// blmHtmlEntities;
