var $, pulse, api_domain = 'https://api.bloom.li';
var meta = {
	lat : {
		pre : 'lat',
		val : ''
	},
	lng : {
		pre : 'lng',
		val : ''
	},
	address : {
		pre : 'address',
		val : ''
	},
	akey : {
		pre : 'akey',
		val : ''
	},
	params : '',
	url : encodeURI( window.location.pathname )
};

/**
* onload
* Actions to perform on window load
*/
jQuery(function() {
	$ = jQuery.noConflict();
	nnsLoadDoc();
} );// Onload

/**
* nnsLoadDoc
* Load the plugin when document is ready
*/
function nnsLoadDoc() {

	// Load search
	setTimeout( nnsLoad, 2000 );

	// Button listeners
	$( document ).on( 'click', 'blm-link', function() {
		nnsTrigger( this, 'BP-001-03' );
	} );

	$( document ).on( 'click', 'blm-button', function() {
		nnsTrigger( this, 'BP-001-02' );
	} );

	// Scroll listener
	$( window ).on( 'scroll', function () {

		if( document.documentElement.scrollHeight <= ( ( document.documentElement.scrollTop || document.body.scrollTop ) + window.innerHeight ) &&
		( ! $( '#blm-search' ) || $( '#blm-search' ).attr('data-display' ) !== 1 ) ) {

			nnsLaunch( 1, 'BP-001-04' );

		}

	} );

}// nnsLoadDoc

/**
* nnsLoad
* Load the search plugin
*/
function nnsLoad() {

	// Check requirements
	if( $( 'bloom' ) === undefined ) {
		return true;
	}

	//Define bloom element
	var bloom = $( 'bloom' ).eq(0);

	// Initialize
	nnsGetMetadata();
	var style = 'circle';

	// Add footer and CSS
	bloom.html( '<div id="blm-footer" data-style="' + style + '" data-has-tooltip="true" data-pulse="true"><div class="blm-tooltip" style="display: none;">Search Nearby</div><div id="blm-pulse"></div><div id="blm-f-c-overlay"></div></div>' );

	// Check custom color
	$( '#blm-footer' ).attr( 'style', 'background-color:#' + bloom.attr( 'data-color' ) + ' !important' );
	$( '#blm-pulse' ).attr( 'style', 'border-color:#' + bloom.attr( 'data-color' ) + ' !important' );

	// Display tab
	setTimeout( function() {

		$( '#blm-footer' ).attr( 'data-display', 1 );

		$( '#blm-f-c-overlay' ).on( 'click', function() {
			nnsLaunch( 1 );
		} );

	}, 100 );

	// Add border pulse for circle
	if( style === 'circle' ) {

		// Pulse animation
		var pulse_num = 3;
		var pulse_duration = 2;
		var pulse_delay = 10;
		var pulse_active = pulse_num * pulse_duration;	

		setTimeout( function() {
			if( $( '#blm-footer' ) ) {
				$( '#blm-footer' ).attr( 'data-pulse', 'false' );
			}
		}, pulse_active * 1000 );

		pulse = setInterval( function() {
			$( '#blm-footer' ).attr( 'data-pulse', 'true' );
			setTimeout( function() {
				$( '#blm-footer' ).attr( 'data-pulse', 'false' );
			}, pulse_active * 1000 );
		}, ( pulse_active + pulse_delay ) * 1000 );

	}

	// Fill HTML
	var blmSearchDiv = document.createElement( 'div' );
	blmSearchDiv.setAttribute( 'id', 'blm-search' );
	blmSearchDiv.setAttribute( 'data-display', '0' );
	blmSearchDiv.setAttribute( 'data-color', bloom.attr( 'data-color' ) );
	$( 'body' ).eq(0).append( blmSearchDiv );

}// nnsLoad

/**
* nnsLaunch
* Launch the search toolbar
*/
function nnsLaunch( params, source ) {

	// Launch search toolbar
	var search = $( '#blm-search' );

	if( search && search.html() ) {
		if( params || search.attr( 'data-display' ) === '0' ) {
			nnsOpen( params );
		} else {
			nnsClose();
		}
	} else {
		nnsInit( params, source );
	}

	// Stop pulse interval
	if( pulse ) {
		clearInterval( pulse );
	}

}// nnsLaunch

/**
* nnsInit
* Initialize search toolbar
*/
function nnsInit( params, source ) {

	// Check requirements
	if( $( 'bloom' ) === undefined ) {
		return true;
	}

	// Define bloom element
	var bloom = $( 'bloom' ).eq(0);

	// Get size of window
	var size_l = 1;
	var size_w = Math.floor( ( window.innerWidth || document.documentElement.clientWidth || document.body.clientWidth ) * 0.01 ) * 100;
	var size_h = Math.floor( ( window.innerHeight || document.documentElement.clientHeight || document.body.clientHeight ) * 0.01 ) * 100;
	var blmSearchDiv = $( '#blm-search' );

	if( params ) {
		nnsResize( params );
	}else{
		nnsResize( size_l );
	}

	// Get source of event
	if( ! source ) {
		source = '';
	} else {
		source = '&amp;source=' + source;
	}

	// Get Google API key
	var google_key = bloom.attr( 'data-google-key' );
	var google_key_param = '';
	if( google_key ) {
		google_key_param = '&amp;google_key=' + google_key;
	}

	blmSearchDiv.html( '<div id="blm-s-h" style="background-color:#' + bloom.attr( 'data-color' ) + ' !important"></div><div id="blm-s-h-overlay" style="background-color:#' + bloom.attr( 'data-color' ) + ' !important"><button></button></div><div class="blm-s-c"><div id="blm-s-local"><a href="javascript:;" class="blm-s-input-alts" id="blm-s-input-geolocation" title="Get my current location"></a><a href="javascript:;" id="blm-s-expand"></a><a href="javascript:;" id="blm-s-close"></a></div><div id="blm-s-remote"><iframe src="' + api_domain + '/embed/plugin/' + bloom.attr( 'data-plugin' ) + '?' + meta.params + '&size_l=' + size_l + '&size_w=' + size_w + '&size_h=' + size_h + source + google_key_param + '" width="' + size_w + '" height="600" allowtransparency="true" style="border:none;visibility:visible;width:' + size_w + 'px;max-width:100%;height:600px;" id="blm-s-iframe-content"></iframe></div></div>' );

	setTimeout( function() {

		// Add geolocation if supported by browser
		nnsTechSupports( 'geolocation', function( res ) {
			if( res === true ) {
				$( '#blm-s-input-geolocation' ).attr( 'data-enabled', 1 );
				$( '#blm-s-input-geolocation' ).on( 'click', nnsGeolocation );
			} else {
				$( '#blm-s-input-geolocation' ).attr( 'data-enabled', 0 );
			}
		} );

		// Close search event
		$( '#blm-s-close' ).on( 'click', nnsClose );

		// Resize search event
		$( '#blm-s-expand' ).on( 'click', nnsResize );
		$( '#blm-s-h-overlay' ).on( 'click', nnsResize );

		// Iframe event
		var iframeListener = addEventListener( 'blur', function() {

			// Wait for document var to update
			setTimeout( function() {

				if( document.activeElement === document.getElementById( 'blm-s-iframe-content' ) ) {
					nnsResize( 2 );
				}

				removeEventListener( 'blur', iframeListener );

			}, 10 );

		} );

		// Display search
		setTimeout( nnsOpen, 100 );

	}, 500 );

}// nnsInit

// Close search trigger
document.onkeyup = function( e ) {
	nnsKeyUp( e );
};

/**
* nnsKeyUp
* Handle search close request
*/
function nnsKeyUp( e ) {

	if( ! $( '#blm-search' ) ) {
		return true;
	}

	e = e || window.event;

	if( e.keyCode === 27 ) {
		if( $( '#blm-search' ) && $( '#blm-search' ).attr( 'data-display' ) === '1' ){ nnsClose(); }
		if( $( '#blm-map-screen' ) && $( '#blm-map-screen' ).attr( 'data-display' ) === '1' ){ nnsMapClose(); }
	}

}// nnsKeyUp

/**
* nnsOpen
* Open the search plugin
*/
function nnsOpen( params ) {

	$( '#blm-search' ).attr( 'data-display', '1' );

	if( params ) {
		nnsResize( params );
	}

	$( '#blm-footer' ).attr( 'data-display', '0' );

}// nnsOpen

/**
* nnsClose
* Close the search plugin
*/
function nnsClose() {

	// Update search
	$( '#blm-search' ).attr( 'data-display', '0' );
	$( '#blm-footer' ).attr( 'data-display', '1' );
	$( 'body' ).eq(0).removeAttr( 'data-bloom' );

}// nnsClose

/**
* nnsGetMetadata
* Get the location of the page
*/
function nnsGetMetadata() {

	var p, c;

	// Get metadata properties
	$( 'meta' ).each( function() {
		p = $( this ).attr( 'property' );
		c = $( this ).attr( 'content' );
		if( ! p || ! c ) { return true; }
		if( p === 'geo:latitude' ){ meta.lat.val = c; return true; }
		if( p === 'geo:longitude' ){ meta.lng.val = c; return true; }
		if( p === 'geo:formatted_address' ){ meta.address.val = encodeURIComponent( c ); return true; }
		if( p === 'bloom:key' ){meta.akey.val = c; return true; }
	} );

	// Handle requirements
	if( ! meta.lat.val || ! meta.lng.val ) {
		meta.lat.val = '';
		meta.lng.val = '';
		meta.address.val = '';
		return true;
	}

	// Format parameters
	meta.lat.val = encodeURI( meta.lat.val );
	meta.lng.val = encodeURI( meta.lng.val );
	meta.params = meta.akey.pre + '=' + meta.akey.val + 
		'&' + meta.lat.pre + '=' + meta.lat.val + 
		'&' + meta.lng.pre + '=' + meta.lng.val + 
		'&' + meta.address.pre + '=' + meta.address.val;

}// nnsGetMetadata

/**
* nnsGeolocation
* Get the location of a user via web browser geolocation
*/
function nnsGeolocation() {

	// Initialize
	$( '#blm-s-input-geolocation' ).attr( 'data-loading', 1 );

	// Return error if browser doesn't support geolocation
	if( ! navigator.geolocation ) {
		nnsGeolocationResponse( { code : 4 } );
		return false;
	}

	// Get current position
	navigator.geolocation.getCurrentPosition (
		function( position ) {
			var geocoder = new google.maps.Geocoder();
			var latlng = new google.maps.LatLng( position.coords.latitude, position.coords.longitude );
			geocoder.geocode( { 'latLng': latlng }, function( nav_results, status ) {
				if( nav_results && nav_results[0] ) {
					nnsGeolocationResponse( {
						code : 5,
						loc : [
							'geodata_lat=' + encodeURI( nav_results[0].geometry.location.lat() ),
							'geodata_lng=' + encodeURI( nav_results[0].geometry.location.lng() ),
							'geodata_address=' + encodeURIComponent( nav_results[0].formatted_address )
						]
					} );
				}
			} );
		},
		function( error ){
			nnsGeolocationResponse( { code : error.code } );
		}
	);

	// Resize layout
	nnsResize( 2 );

}// nnsGeolocation

/**
* nnsGeolocationResponse
* Handle response from geolocation input
*/
function nnsGeolocationResponse( result ) {

	// Update main frame
	var frame = $( '#blm-s-remote' );
	frame = frame.find( 'iframe' ).eq(0);
	var frame_src = frame.attr( 'src' );
	var frame_parts = frame_src.split( '&' );

	// Remove previous updated time
	if( frame_parts[ frame_parts.length - 1 ].indexOf( 'geodata_address=' ) === 0 ){
		return false;
	}

	// Add geolocation
	var result_loc = '';
	if( result.loc ) {
		result_loc = '&' + result.loc.join( '&' );
	}
	frame_src = frame_parts.join( '&' ) + '&geocode=' + result.code + result_loc;
	frame.attr( 'src', frame_src );

	// Hide local geolocation link
	setTimeout( function() {
		$( '#blm-s-input-geolocation' ).css( 'display', 'none' );
	}, 1000 );

}// nnsGeolocationResponse

/**
* nnsResize
* Resize the plugin layout
*/
function nnsResize( force ) {

	//Update force
	if(typeof force === 'object'){
		force = null;
	}

	var size_l = null;

	// Determine size
	if( force ) {
		size_l = force;
	}else{
		if( $( '#blm-search' ).attr( 'data-layout' ) === '1' ) {
			size_l = 2;
		} else {
			size_l = 1;
		}
	}

	// Force mobile layout
	if( nnsIsMobile() ) {
		size_l = 2;
	}

	// Set layout
	$( '#blm-search' ).attr( 'data-layout', size_l );

	if( size_l === '2' ) {
		$( 'body' ).eq(0).attr( 'data-bloom', 'nns' );
	} else {
		$( 'body' ).eq(0).removeAttr( 'data-bloom' );
	}

}// nnsResize

/**
* nnsTrigger
* Event listener for buttons and ads
*/
function nnsTrigger( item, search_code ) {

	if( ! $(item).attr( 'data-type' ) ) {
		return false;
	}

	switch( $(item).attr( 'data-type' ) ) {

		case 'search':

			nnsLaunch( 2, search_code );

			break;

		case 'map':

			if( ! meta.akey.val ) {
				$(item).css( 'display', 'none' );
				break;
			}

			nnsMapLaunch();

			break;

		default:

			break;

	}

}// nnsTrigger

/**
* nnsMapLaunch
* Launch a map
*/
function nnsMapLaunch() {

	// Handle if map was previously launched
	if( $( '#blm-map-screen' ).length ) {

		// Display map
		$( '#blm-map-screen' ).attr( 'data-display', '1' );

	} else {

		if( ! meta.akey.val ) {
			return false;
		}

		// Create and display map
		var screen = document.createElement( 'div' );
		screen.setAttribute( 'id', 'blm-map-screen' );
		screen.setAttribute( 'data-display', '1' );
		screen.innerHTML = '<div id="blm-map-screen-content"><div id="blm-map-screen-close"><svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 20 20" width="20" height="20"><path d="M19 6.41L17.59 5 12 10.59 6.41 5 5 6.41 10.59 12 5 17.59 6.41 19 12 13.41 17.59 19 19 17.59 13.41 12z"></path></svg></div><iframe src="' + api_domain + '/embed/article/map?' + meta.akey.pre + '=' + meta.akey.val + '&amp;size=rect&amp;zoom=16&amp;source=BP-007-01" name="Map" style="border:none;visibility:visible;width:100% !important;max-width:600px;height:235px"></iframe></div>';
		$( 'body' ).eq(0).append( screen );

		// Close map listener
		$( '#blm-map-screen-close' ).on( 'click', nnsMapClose );

	}

}// nnsMapLaunch

/**
* nnsMapClose
* Close a map
*/
function nnsMapClose() {

	if( $( '#blm-map-screen' ) ) {
		$( '#blm-map-screen' ).attr( 'data-display', '0' );
	}

}// nnsMapClose

/**
* nnsTechSupports
* Check if the browser supports a function
*/
function nnsTechSupports( type, callback ) {

	// Get browser
	var M = navigator.userAgent.match( /(opera|chrome|safari|firefox|msie|trident(?=\/))\/?\s*(\d+)/i ) || [];

	// Check if Chrome and client is not https
	var chromeStrict = false;
	if( M[1] === 'Chrome' && M[2] > 49 && window.location.protocol !== 'https:' ) {
		chromeStrict = true;
	}

	// If geolocation is not supported
	if( type === 'geolocation' && ( typeof( google ) === undefined || navigator.geolocation === undefined || chromeStrict ) ) {
		return callback( false );
	}

	return callback( true );

}// nnsTechSupports

/**
* nnsIsMobile
* Check if user device should render mobile display
*/
function nnsIsMobile(){

	if( Math.max( document.documentElement.clientWidth, window.innerWidth || 0 ) < 900 ) {
		return true;
	}

	return false;

}// nnsIsMobile
